# pay

`POST /v1/payments/pay`

Use this API to get the checkout address. After getting the checkout address, you can redirect the buyer to the address to make a payment.

# Structure

A message consists of a header and body. The following sections are focused on the body structure. For the header structure, see： 

-   [Request header](https://docs.antom.com/ac/ams/api_fund.md#ML5ur)
-   [Response header](https://docs.antom.com/ac/ams/api_fund.md#WWH90)

> **Note**: Set the data type of each field (except array) as String. This means that you must use double quotation marks (" ") to enclose the field value. Examples:
>
> -   If the data type of a field is Integer and its value is `20`, set it as "`20`". 
> -   If the data type of a field is Boolean and its value is `true`, set it as "`true`".

## Request parameters

#### productCode (String, REQUIRED)

Represents the payment product that is being used, which is stipulated in the contract. For One-time Payments, the value is fixed as `CASHIER_PAYMENT`.

#### paymentRequestId (String, REQUIRED)

The unique ID assigned by a merchant to identify a payment request. APO uses this field for idempotence control.

More information:

- This field is an API idempotency field.For payment requests that are initiated with the same value of paymentRequestId and reach a final status of S or F, the same result is to be returned for the request.
- Maximum length: 64 characters

#### order (Order, REQUIRED)

The order information, such as buyer, merchant, goods, amount, shipping information, and purchase environment. This field is used for different purposes:

-   During the payment process, this field is mainly used by APO for risk control or anti-money laundering.
-   After the payment is completed, this field is used for recording and reporting purposes such as purchase tracking and regulatory reporting.

##### orderAmount (Amount, REQUIRED)

The order amount of the merchant that directly provides services or goods to the customer. This field is used for user consumption records display or payment results page.

###### currency (String, REQUIRED)

The transaction currency that is specified in the contract. A 3-letter currency code that follows the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard.

More information:

- Maximum length: 3 characters

###### value (Integer, REQUIRED)

The amount to charge as a positive integer in the smallest currency unit. (That is, 100 cents to charge $1.00, or 100 to charge JPY 100, a 0-decimal currency).

> **Note**: For details about the smallest currency unit, see [Smallest unit of the currency](https://docs.antom.com/ac/ref/cc.md#ONkIe).

More information:

- Value range: 1 - unlimited

##### referenceOrderId (String, REQUIRED)

The unique ID to identify the order on the merchant side, which is assigned by the merchant that provides services or goods directly to the customer. This field is used for user consumption records display and other further actions such as disputes track or handling of customer complaints.

More information:

- Maximum length: 64 characters

##### orderDescription (String, REQUIRED)

Summary description of the order, which is used for user consumption records display or other further actions.

More information:

- Maximum length: 256 characters

##### goods (Array<Goods>)

Goods information, including the ID, name, price, and quantity of the goods in the order.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum size: 100 elements

###### referenceGoodsId (String, REQUIRED)

The unique ID to identify the goods.

More information:

- Maximum length: 64 characters

###### goodsName (String, REQUIRED)

Goods name.

More information:

- Maximum length: 256 characters

###### goodsCategory (String)

The category of the goods. If the goods have multiple layers for categorization, use slashes between different categories and write the parent category before the subcategory, such as `Digital Goods/Digital Vouchers/Food and Beverages`.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

###### goodsUnitAmount (Amount)

Price of goods.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### currency (String, REQUIRED)

The 3-letter currency code that follows the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard.

More information:

- Maximum length: 3 characters

###### value (Integer, REQUIRED)

The amount to charge as a positive integer in the smallest currency unit. (That is, 100 cents to charge $1.00, or 100 to charge JPY 100, a 0-decimal currency).

> **Note**: For details about the smallest currency unit, see [Smallest unit of the currency](https://docs.antom.com/ac/ref/cc.md#ONkIe).

More information:

- Value range: 1 - unlimited

###### goodsQuantity (Integer)

Quantity of goods.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Value range: 1 - unlimited

###### goodsUrl (String)

The URL of the website where the user places an order.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to identify black-market behavior.

More information:

- Maximum length: 2048 characters

###### deliveryMethodType (String)

The delivery method of the goods. Valid values are:

-   `PHYSICAL`: indicates that the delivery method is physical delivery.
-   `DIGITAL`: indicates that the delivery method is digital delivery.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 32 characters

##### shipping (Shipping)

Shipping information, including information about the recipient (name, phone number, email, and shipping address), and shipping service provider.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `OVO` and you collect this information during the payment process.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### shippingName (UserName)

The name of the recipient.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### firstName (String, REQUIRED)

First name.

More information:

- Maximum length: 32 characters

###### middleName (String)

Middle name

More information:

- Maximum length: 32 characters

###### lastName (String, REQUIRED)

Last name

More information:

- Maximum length: 32 characters

###### fullName (String)

Full name

More information:

- Maximum length: 128 characters

###### shippingAddress (Address)

The shipping address.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   The value of _paymentMethodType_ is `PAGALEVE`.
> -   You require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### region (String, REQUIRED)

The 2-letter country or region code. For more information, see [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search) standard.

More information:

- Maximum length: 2 characters

###### state (String)

The state, country, or province name.

> **Note**: For card payments, if your business entity is in the United States, and the card issuing country is in Canada, the United States, or the United Kingdom, set the value to a region code that consists of two to three characters and follows the ISO 3611-2 standard.

More information:

- Maximum length: 8 characters

###### city (String)

The city, district, suburb, town, or village name.

More information:

- Maximum length: 32 characters

###### address1 (String)

Address line 1, for example, the street address, PO box, and company name.

More information:

- Maximum length: 256 characters

###### address2 (String)

Address line 2, for example, the apartment, suite, unit, and building information.

More information:

- Maximum length: 256 characters

###### zipCode (String)

ZIP or postal code.

> **Note**:
>
> For card payments, if your business entity is in the United States, specify this parameter according to the following parameter value requirements:
>
> -   Only contains numbers, letters, hyphens, and spaces.
> -   Must be within ten characters.

More information:

- Maximum length: 32 characters

###### shippingCarrier (String)

The delivery service provider for shipping a physical product, such as FedEx, UPS, or USPS.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 128 characters

###### shippingPhoneNo (String)

The phone number of a recipient (including extension).

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `OVO` and you collect the phone number that is bound to the OVO account during the payment process.  
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 16 characters

###### shipToEmail (String)

The email address where virtual goods are sent.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   if you require risk control.
> -   if you are a digital and entertainment merchant.
>
> Providing this information helps to increase fraud and identity theft detection.

More information:

- Maximum length: 64 characters

##### buyer (Buyer)

Buyer information, including the ID, name, phone number, and email of the buyer.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `CARD`, `OVO`, `BANCOMATPAY`, `KONBINI`, `BANKTRANSFER_PAYEASY`, or `ONLINEBANKING_PAYEASY` and you collect this information during the payment process.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### referenceBuyerId (String)

The unique ID to identify the buyer.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   When you require risk control.
> -   When the value of _paymentMethodType_ is `CARD`.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

###### buyerName (UserName)

The name of the buyer.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `KONBINI` , `BANKTRANSFER_PAYEASY`, or `ONLINEBANKING_PAYEASY` and you collect this information during the payment process.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### firstName (String, REQUIRED)

First name.

More information:

- Maximum length: 32 characters

###### middleName (String)

Middle name

More information:

- Maximum length: 32 characters

###### lastName (String, REQUIRED)

Last name.

More information:

- Maximum length: 32 characters

###### fullName (String)

Full name

More information:

- Maximum length: 128 characters

###### buyerPhoneNo (String)

The mobile phone number of the buyer.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `CARD`.
> -   The value of _paymentMethodType_ is `KONBINI` , `BANKTRANSFER_PAYEASY`, or `ONLINEBANKING_PAYEASY` and you collect the phone number during the payment process.
> -   The value of _paymentMethodType_ is `OVO` or `BANCOMATPAY` and you collect the phone number that is bound to the OVO or Bancomat Pay account during the payment process.  
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 24 characters

###### buyerEmail (Email)

The email of the buyer.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   When you require risk control.
> -   When the value of _paymentMethodType_ is `CARD`.
> -   The value of _paymentMethodType_ is `KONBINI`, `BANKTRANSFER_PAYEASY`, or `ONLINEBANKING_PAYEASY` and you collect this information during the payment process.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

###### buyerRegistrationTime (Datetime)

The time when the buyer registered your account.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

##### merchant (Merchant)

Information about the secondary merchant.

> **Note**: Specify this field if you are an acquirer that has secondary merchants.

###### referenceMerchantId (String, REQUIRED)

The ID to identify the merchant that directly provides services or goods to the customer.

More information:

- Maximum length: 32 characters

###### merchantMCC (String)

The secondary merchant category code, which is a 4-digit number listed in [MCC codes](https://docs.antom.com/ac/ref/mcccodes.md).

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 32 characters

###### merchantName (String)

The merchant name.

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 256 characters

###### merchantDisplayName (String)

The merchant name to be displayed.

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

###### merchantAddress (Address)

The merchant address information.

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

###### region (String, REQUIRED)

The two-character [ISO 3166](https://www.iso.org/iso-3166-country-codes.html) country/region code.

More information:

- Maximum length: 2 characters

###### state (String)

The state, country, or province.

More information:

- Maximum length: 8 characters

###### city (String)

The city, district, suburb, town, or village.

More information:

- Maximum length: 32 characters

###### address1 (String)

Address line 1, such as street, PO Box, or company name.

More information:

- Maximum length: 256 characters

###### address2 (String)

Address line 2, such as the apartment, suite, unit, or building information.

More information:

- Maximum length: 256 characters

###### zipCode (String)

ZIP or postal code.

More information:

- Maximum length: 32 characters

###### merchantRegisterDate (Datetime)

Merchant registration date.

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

##### extendInfo (String)

Extended information data, including information for special use cases.

> **Note**: Specify this field when you need to use the extended information.

###### chinaExtraTransInfo (ChinaExtraTransInfo)

Extra information about the transaction.

> **Note**: Specify this field for transactions to AlipayCN.

###### businessType (String, REQUIRED)

The business type. Valid values are:

-   `1`: Hotel
-   `2`: Air Flight
-   `3`: Study Abroad
-   `4`: Trade
-   `5`: Other

Multiple business types are delimited by "|".

More information:

- Maximum length: 16 characters

###### flightNumber (String)

The flight number. Multiple flight numbers are delimited by '|'.

> **Note**: When _businessType_\=2, this field needs to be specified.

More information:

- Maximum length: 1000 characters

###### departureTime (Datetime)

The flight departure time in the format of yyyy-MM-dd HH:mm. Multiple flight departure times are delimited by '|'.

> **Note**: When _businessType_\=2, this field needs to be specified.

More information:

- Maximum length: 1000 characters
- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

###### hotelName (String)

The hotel name. Multiple hotel names are delimited by '|'.

> **Note**: When _businessType_\=1, this field needs to be specified.

More information:

- Maximum length: 1000 characters

###### checkinTime (Datetime)

The hotel check-in time in the format of yyyy-MM-dd and in the UTC+8 timezone. Multiple hotel check-in times are delimited by '|'.

> **Note**: When _businessType_\=1, this field needs to be specified.

More information:

- Maximum length: 1000 characters
- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

###### admissionNoticeUrl (URL)

The school admission notice URL. Mulitple URLs are delimited by '|'.

> **Note**: When _businessType_\=3, this field needs to be specified.

More information:

- Maximum length: 1000 characters

###### goodsInfo (String)

Goods information that includes SKU names and corresponding quantities, in the format of SKU\_name^quantity. If more than one goods exists, separate values with a vertical bar (|).

> **Note**: Specify this field only when _business\_type_ is 4 (Sales of goods). When _businessType_\=4, this field needs to be specified.

More information:

- Maximum length: 2000 characters

###### totalQuantity (Integer)

Total quantities of all goods in one order.

> **Note**: Specify this field only when _business\_type_ is 4 (Sales of goods).

More information:

- Value range: 0 - unlimited

#### paymentAmount (Amount, REQUIRED)

The payment amount that the merchant requests to receive in the order currency.

##### currency (String, REQUIRED)

The transaction currency, which is a 3-letter currency code that follows the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard.

More information:

- Maximum length: 3 characters

##### value (Integer, REQUIRED)

The value of the amount as a positive integer in the smallest currency unit. For example, if the currency is USD and the amount is $1.00, set the value of this parameter to `100`; or if the currency is JPY and the amount is ￥1, set the value of this parameter to `1`. 

For details about the smallest currency unit, see [Smallest unit of the currency](https://docs.antom.com/ac/ref/cc.md#ONkIe).

For details about the minimum payment amount allowed for each payment method, see [Minimum amount rules](https://docs.antom.com/ac/ref/cc.md#q9R5A).

> **Note**: Due to the currency practices in Indonesia, when the currency is IDR, round the amount with banker's rounding and fix the last two digits of this parameter as `00`.

More information:

- Value range: 1 - unlimited

#### paymentFactor (PaymentFactor)

Factors that impact the payment. This field is used to indicate the payment scenario.

> **Note**: Specify this parameter when the value of _paymentMethodType_ is `CARD`. ****

##### isAuthorization (Boolean)

Indicates whether the payment scenario is authorization. Valid values of this parameter are:

-   `true`: indicates that the payment scenario is authorization.
-   `false`: indicates that the payment scenario is a regular payment without authorization.  

Under the authorization scenario, the payment funds are guaranteed and held on the payment method side. You can use the **capture** API to deduct the payment funds.

> **Note**: Specify this parameter when the value of _paymentMethodType_ is `CARD`.

##### captureMode (string)

Indicates the method for capturing funds after the user authorizes the payment. Valid values are:

-   `AUTOMATIC`: indicates that Alipay+ automatically captures the funds after the authorization. The same applies when the value is empty or you do not pass in this parameter.
-   `MANUAL`: indicates that you manually capture the funds by calling the **capture** API.

> **Note**: Specify this parameter if you want to designate the capture mode of the payment.

More information:

- Maximum length: 64 characters

#### paymentMethod (PaymentMethod, REQUIRED)

The payment method that is used to collect the payment by the merchant or acquirer.

##### paymentMethodType (String, REQUIRED)

The payment method type that is included in payment method options.

> **Note**: By specifying the value of this parameter, you can receive the cashier URL of the specified payment method returned by APO. See [APO payment methods](https://docs.antom.com/ac/apo/payment_methods.md) to check the valid values.

More information:

- Maximum length: 64 characters

##### paymentMethodId (String)

The unique ID that is used to identify a payment method. The value of this parameter is that of _cardToken_ obtained from the **notifyPayment** or **inquiryPayment** API.

> **Note**: Specify this parameter when the value of _paymentMethodType_ is `CARD`.

More information:

- Maximum length: 128 characters

##### paymentMethodMetaData (PaymentMethodMetaData object)

Additional information required for some specific payment methods.

> **Note**: Specify this parameter when the value of _paymentMethodType_ is `BLIK`, `P24` , `CARD`, `IDEAL`, `MERCADOPAGO_BR`, `MERCADOPAGO_MX`, `MERCADOPAGO_CL`, `MERCADOPAGO_PE`, `ONLINEBANKING_FPX`, or `PAGALEVE`.

**Scenario: Blik** (Blik)

###### blikCode (String)

The unique 6-digit BLIK code that is generated on the user's banking application. The code expires in 2 minutes.

Specify this parameter when all the following conditions are met:

-   The value of _paymentMethodType_ is `BLIK`.  
-   You collect this information during the payment process.

More information:

- Maximum length: 6 characters

**Scenario: Przelewy24** (Przelewy24)

###### payerEmail (Email )

The email address of the payer. 

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `P24`. 
-   You collect this information during the payment process.

More information:

- Maximum length: 64 characters

###### bankIdentifierCode (String)

The unique code of the bank. See [Bank list](https://global.alipay.com/docs/ac/ref/payment_method#1QVov) to check the valid values. 

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `P24`. 
-   You collect this information during the payment process.

**Scenario: Card** (Card)

###### is3DSAuthentication (Boolean)

Indicates whether the transaction authentication type is 3D secure. Specify this parameter when the value of _paymentMethodType_ is `CARD`. Valid values of this parameter are:

-   `true`: indicates that the transaction authentication type is 3D secure.
-   `false`: indicates that the transaction authentication type is 2D authentication.

If the value of this parameter is empty or the parameter is not passed, the transaction authentication type is determined by the acquirer.

###### cardNo (String)

The card number.

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`. 
-   You collect this information during the payment process.

> If you set the value of _paymentMethod.paymentMethodMetaData.tokenize_ to `true` when the user saves the card on your cashier page, you do not need to specify this parameter for subsequent payments using the same card.

More information:

- Maximum length: 32 characters

###### cvv (String)

The card verification value (CVV), which is also known as a card security code (CSC) or a card veirification code (CVC).

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `GLOBAL`, `BR`, `CL`, `MX`, or `PE`.  
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 4 characters

###### expiryYear (String)

The year the card expires. Pass in the last two digits of the year number. For example, if the expiry year is 2025, the value of this parameter is `25`.

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`. 
-   You collect this information during the payment process.

> **Note**: If you set the value of _paymentMethod.paymentMethodMetaData.tokenize_ to `true` when the user saves the card on your cashier page, you do not need to specify this parameter for subsequent payments using the same card.

More information:

- Maximum length: 2 characters

###### expiryMonth (String)

The month the card expires. Pass in two digits representing the month. For example, if the expiry month is February, the value of this parameter is `02`.

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`. 
-   You collect this information during the payment process.

> If you set the value of _paymentMethod.paymentMethodMetaData.tokenize_ to `true` when the user saves the card on your cashier page, you do not need to specify this parameter for subsequent payments using the same card.

More information:

- Maximum length: 2 characters

###### cardholderName (UserName)

The cardholder's name.

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `BR`, `CL`, `MX`, or `PE`.
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

> **Note**: If you set the value of _paymentMethod.paymentMethodMetaData.tokenize_ to `true` when the user saves the card on your cashier page, you do not need to specify this parameter for subsequent payments using the same card.

###### firstName (String, REQUIRED)

The cardholder's first name.

More information:

- Maximum length: 32 characters

###### middleName (String)

The cardholder's middle name.

More information:

- Maximum length: 32 characters

###### lastName (String, REQUIRED)

The cardholder's last name.

More information:

- Maximum length: 32 characters

###### fullName (String)

The cardholder's full name.

More information:

- Maximum length: 128 characters

###### billingAddress (Address)

The billing address that is associated with the cardholder's card account.

Specify this parameter when _paymentMethodType_ is `CARD` and you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

> **Note**: If you set the value of _paymentMethod.paymentMethodMetaData.tokenize_ to `true` when the user saves the card on your cashier page, you do not need to specify this parameter for subsequent payments using the same card.

###### region (String, REQUIRED)

The 2-letter country or region code. For more information, see [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search) standard.

More information:

- Maximum length: 2 characters

###### state (String)

> For card payments, if your business entity is in the United States, and the card issuing country is in Canada, the United States, or the United Kingdom, set the value to a region code that consists of two to three characters and follows the ISO 3611-2 standard.

More information:

- Maximum length: 8 characters

###### city (String)

The city, district, suburb, town, or village name.

More information:

- Maximum length: 32 characters

###### address1 (String)

Address line 1, for example, the street address, PO box, and company name.

More information:

- Maximum length: 256 characters

###### address2 (String)

Address line 2, for example, the apartment, suite, unit, and building information.

More information:

- Maximum length: 256 characters

###### zipCode (String)

> For card payments, if your business entity is in the United States, specify this parameter according to the following parameter value requirements:
>
> -   Only contains numbers, letters, hyphens, and spaces.
> -   Must be within ten characters.

More information:

- Maximum length: 32 characters

###### cpf (String)

The Cadastro Pessoal de Pessoa Física (CPF) is the tax ID of the Brazilian individual taxpayer.

Specify this parameter when all the following conditions are met: 

-   When the value _paymentMethodRegion_ is `BR`.
-   You collect this information during the payment process.   

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 11 characters

###### dateOfBirth (String)

The date of birth of the cardholder. The value of this parameter is an 8-digit date of birth in the format of `YYYY-MM-DD` that follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard. For example, `1971-06-07` means the cardholder's birthday is June 7, 1971.  

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `KR`.
-   The card is a personal card.
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 10 characters

###### businessNo (String)

The business number of the company that holds the corporate card. The value of this parameter is a 10-digit business number, such as `97XXXXXX11`. 

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `KR`.
-   The card is a corporate card.
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 10 characters

###### cardPasswordDigest (String)

The first two digits of the card payment password. 

Specify this parameter when all the following conditions are met: 

-   You have the PCI qualification.
-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `KR`.
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 2 characters

###### paymentMethodRegion (String)

The region code that represents the country or region of the payment method. The value of this parameter is a 2-letter [ISO country code](https://www.iso.org/obp/ui/#search) or `GLOBAL`. 

Specify this parameter when the card is a dual currency card. If you do not specify this parameter, APO makes an intelligent decision for you based on the payment success rate and other factors.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 6 characters

###### payerEmail (Email)

The email address of the payer. 

Specify this parameter when all the following conditions are met:

-   _paymentMethodType_ is `CARD`.
-   _paymentMethodRegion_ is `BR`, `CL`, `MX`, or `PE`.
-   You collect this information during the payment process.  

For more information about the card region, see [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S).

More information:

- Maximum length: 64 characters

###### tokenize (Boolean)

Deprecated. Use _tokenizeMode_ instead.

###### tokenizeMode (String)

The tokenize mode. Indicates whether card information needs to be stored. When you opt to store card details, the actual information is replaced with a unique and secure token that can be used for future payments. Valid values are:

-   `ENABLED`: indicates that you obtain card binding authorization and want to store card information for future payments.
-   `DISABLED`: indicates that you don’t need to store card information. The same applies when the value is empty or you do not specify this parameter.
-   `ASKFORCONSENT`: indicates that you present a button on the page, allowing the buyer to choose whether or not they want to store the card information.

More information:

- Maximum length: 64 characters

###### isCardOnFile (Boolean)

Indicates whether the user's card payment information is stored. Valid values are:

-   `true`: indicates that the user's card payment information is stored.
-   `false`: indicates that the user's card payment information is not stored. The same applies when the value is empty or you do not specify this parameter.

Specify the value of this parameter as `true` when the user pays with a saved card.

###### recurringType (String)

The recurring type for the payment. Valid values are:

-   `SCHEDULED`: indicates a regular automated deduction payment.
-   `UNSCHEDULED`: indicates an irregular automated deduction payment.

If the value of this parameter is empty or you do not specify this parameter, the payment is not an automated deduction and the payer will be included in the payment process.

Specify this parameter when the payment is a merchant-initiated transaction (MIT).

More information:

- Maximum length: 64 characters

###### networkTransactionId (String)

The unique ID assigned by the card scheme to identify a transaction. This parameter is used for automated deduction payments. The value of this parameter is the value of the same field that is returned by **notifyPayment** or **inquiryPayment** for the original payment.  

Specify this parameter when the value of _recurringType_ is `SCHEDULED` or `UNSCHEDULED`.

More information:

- Maximum length: 100 characters

###### selectedCardBrand (String)

The card brand that the user used to pay. See [Card brands](https://docs.antom.com/ac/apo_zh-cn/payment_methods.md#c798S) to check the valid values.

Specify this parameter when the card is a dual currency card. If you do not specify this parameter, APO decides which card brand the user uses to pay based on the payment success rate and other factors.

More information:

- Maximum length: 64 characters

###### enableAuthenticationUpgrade (Boolean)

Indicates whether you allow non-3D Secure authentication to be upgraded to 3D Secure authentication. Valid values are:

-   `true`: indicates that you allow non-3D Secure authentication to be upgraded to 3D Secure authentication. The same applies when the value is empty or you do not specify this parameter.
-   `false`: indicates that you do not allow non-3D Secure authentication to be upgraded to 3D Secure authentication.

This parameter is used to salvage some payments that non-3D authentication fails. Specify this parameter as `false` if you do not need this capability.

###### mpiData (MpiData)

The MPI (Merchant Plug-In) information. 

Specify this parameter if you integrate external 3D MPI.

###### threeDSVersion (String, REQUIRED)

The version of 3D Secure protocol. Valid values are:

-   `1.0.2`
-   `2.1.0`
-   `2.2.0`

More information:

- Maximum length: 16 characters

###### cavv (String)

The cardholder authentication value. The value of this parameter can be Cardholder Authentication Verification Value (CAVV) or Authentication Verification Value (AVV).

Specify this parameter when the cardholder passes the 3D Secure authentication.

More information:

- Maximum length: 64 characters

###### dsTransactionId (String)

The unique transaction identifier assigned by the Directory Server (DS) for 3D Secure authentication.

Specify this parameter when 3D Secure authentication is used.

More information:

- Maximum length: 64 characters

###### eci (String, REQUIRED)

Electronic Commerce Indicator (ECI) that is returned by the card scheme. This parameter is used to indicate the type of cardholder identity authentication. Valid values are:

-   `02` or `05`: indicates fully authenticated transaction.
-   `01` or `06`: indicates attempted authentication transaction.
-   `00` or `07`: indicates non-3D Secure transaction.

More information:

- Maximum length: 2 characters

###### passThroughMetadata (String)

A set of key-value pairs that indicate your additional and custom information about the transaction.

> **Note**: Specify this parameter if you want to provide more information about the transaction to your acquirer.

More information:

- Maximum length: 2048 characters

###### requireIssuerAuthentication (Boolean)

Indicates whether Korean card transactions require authentication from the issuing bank. Valid values are:

-   `true`: indicates that Korean card transactions require authentication from the issuing bank.
-   `false`: indicates that Korean card transactions do not require authentication from the issuing bank. The same applies when you do not specify this parameter or the value is empty.

Specify this parameter when all the following conditions are met:

-   The value of _paymentMethodType_ is `CARD`.
-   The value of _paymentMethodRegion_ is `KR`.
-   The Korean card transactions require issuer authentication.

**Scenario: iDEAL** (iDEAL)

###### bankIdentifierCode (String)

The unique code of the bank. The unique code of the bank. See [Bank list](https://global.alipay.com/docs/ac/ref/payment_method#1QVov) to check the valid values. 

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `IDEAL`. 
-   You collect this information during the payment process.

**Scenario: Mercado Pago** (Mercado Pago)

###### payerEmail (Email)

The email address of the payer. 

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `MERCADOPAGO_BR`, `MERCADOPAGO_MX`, `MERCADOPAGO_CL`, or `MERCADOPAGO_PE`.  
-   You collect this information during the payment process.

More information:

- Maximum length: 64 characters

###### cpf (String)

The Cadastro Pessoal de Pessoa Física (CPF) is the tax ID of the Brazilian individual taxpayer.

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `MERCADOPAGO_BR`.  
-   You collect this information during the payment process.

More information:

- Maximum length: 11 characters

**Scenario: FPX** (FPX)

###### bankIdentifierCode (String)

The unique code of the bank. See [Bank list](https://global.alipay.com/docs/ac/ref/payment_method#1QVov) to check the valid values. 

Specify this parameter when all the following conditions are met: 

-   The value of _paymentMethodType_ is `ONLINEBANKING_FPX`. 
-   You collect this information during the payment process.

**Scenario: Pagaleve** (PAGALEVE)

###### cpf (String)

The Cadastro Pessoal de Pessoa Física (CPF) is the tax ID of the Brazilian individual taxpayer.

Specify this parameter when the value of _paymentMethodType_ is `PAGALEVE`.

More information:

- Maximum length: 11 characters

###### payerEmail (Email)

The email address of the payer.

Specify this parameter when the value of _paymentMethodType_ is `PAGALEVE`.

More information:

- Maximum length: 64 characters

###### payerPhoneNo (String)

The phone number of the payer.

Specify this parameter when the value of _paymentMethodType_ is `PAGALEVE`.

More information:

- Maximum length: 24 characters

###### billingAddress (Address)

The billing address that is associated with the cardholder's card account.

Specify this parameter when _paymentMethodType_ is `PAGALEVE`. Providing this information helps to increase payment success rates.

###### region (String, REQUIRED)

The 2-letter country or region code. For more information, see [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search) standard.

More information:

- Maximum length: 2 characters

###### state (String)

The state, country, or province name.

More information:

- Maximum length: 8 characters

###### city (String)

The city, district, suburb, town, or village name.

More information:

- Maximum length: 32 characters

###### address1 (String)

Address line 1, for example, the street address, PO box, and company name.

More information:

- Maximum length: 256 characters

###### address2 (String)

Address line 2, for example, the apartment, suite, unit, and building information.

More information:

- Maximum length: 256 characters

###### zipCode (String)

The ZIP or postal code.

More information:

- Maximum length: 32 characters

###### payerName (UserName)

The payer's name.

Specify this parameter when the value of _paymentMethodType_ is `PAGALEVE`.

###### firstName (String, REQUIRED)

The payer's first name.

More information:

- Maximum length: 32 characters

###### lastName (String, REQUIRED)

The payer's last name.

More information:

- Maximum length: 32 characters

##### customerId (String)

The unique ID to identify a buyer.

> **Note**: Specify this field if you have the information. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 32 characters

##### extendInfo (String)

Extended information.

> **Note**: Specify this field if you need to use the extended information.

More information:

- Maximum length: 2048 characters

#### paymentExpiryTime (Datetime)

The payment expiration time is a specific time after which the payment will expire and the acquirer or merchant must terminate the order processing.

> **Notes**:
>
> -   For bank transfer payments, the default payment expiration time is 48 hours after the payment request is sent. For other payment categories, the default payment expiration time is usually 14 minutes after the payment request is sent. For example, if the request is sent on 2019-11-27T12:00:01+08:30, the payment expiration time is 2019-11-27T12:14:01+08:30.
> -   Specify this field if you want to use a payment expiration time that differs from the default time. For bank transfer payments, the specified payment expiration time must be less than 48 hours after the payment request is sent. For other payment categories, the specified payment expiration time must be less than 10 minutes after the payment request is sent.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

#### paymentRedirectUrl (URL, REQUIRED)

The merchant page URL that the user is redirected to after the payment is completed.

More information:

- Maximum length: 2048 characters

#### paymentNotifyUrl (URL)

The URL that is used to receive the payment result notification.

> **Note**: Specify this parameter if you want to receive an asynchronous notification of the payment result. You can also set the URL to receive the result notification on APO Dashboard. If the URL is specified in both the request and APO Dashboard, the value specified in the request takes precedence.

More information:

- Maximum length: 2048 characters

#### settlementStrategy (SettlementStrategy, REQUIRED)

The settlement strategy for the payment request.

##### settlementCurrency (String, REQUIRED)

The ISO currency code of the currency that the merchant wants to be settled against. The field is required if the merchant signed up for multiple currencies to settle.

More information:

- Maximum length: 3 characters

#### userRegion (String)

A 2-letter country or region code based on the standard of [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search). This parameter is used to sort digital wallets according to the user's region. For example, if `ALIPAY_CN` and `KAKAOPAY` are both on your payment method list and the user is from South Korea, `KAKAOPAY` will be listed first on the APO checkout.

> **Note****:** This parameter is only for the merchant that has integrated the APO checkout.

More information:

- Maximum length: 2 characters

#### creditPayPlan (CreditPayPlan)

The credit payment plan information for this payment.

> **Note**: Specify this field if you want to support installment payment and contact APO technical support for details on how to offer installment payments.

##### installmentNum (String, REQUIRED)

The number of installments. The valid value is from `2` to `12`.

More information:

- Maximum length: 8 characters

##### creditPayFeeType (String)

The value of this field is `PERCENTAGE`, which indicates that the fee is described in percentage with 1 - 3 digits. For example, 5 means 5%, 100 means 100%.

> **Note**: Specify this field when you want the fee information to be expressed in percentage.

##### feePercentage (Integer)

This field is determined by the sellers' liability. For example, 0 indicates the seller is not liable for any fee. 100 indicates the seller pays 100% of the fee.

> **Note**: Specify this field when the value of _creditPayFeeType_ is `PERCENTAGE`.

More information:

- Value range: 0 - 100

#### appId (String)

The unique ID that is assigned by APO to identify the mini program.

> **Note**: This field is required when _terminalType_ is `MINI_APP`.

More information:

- Maximum length: 32 characters

#### merchantRegion (String)

The country or region where the merchant operates the business. The parameter is a 2-letter country or region code that follows [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search) standard.

Some possible values are `US`, `SG`, `HK`, `PK`, `JP`, `CN`, `BR`, `AU`, and `MY`.

> **Note**: This parameter is required when you use the Global Acquirer Gateway (GAGW) product.

More information:

- Maximum length: 2 characters

#### env (Env, REQUIRED)

Information about the environment where the order is placed, such as the device information.

##### terminalType (String, REQUIRED)

Terminal type of which the merchant service applies to. Valid values are:

-   `WEB`: The client-side terminal type is a website, which is opened via a PC browser.
-   `WAP`: The client-side terminal type is an H5 page, which is opened via a mobile browser.
-   `APP`: The client-side terminal type is a mobile application.
-   `MINI_APP`: The terminal type of the merchant side is a mini program on the mobile phone.

##### osType (String)

OS type. Valid values are:

-   `IOS`: indicates the operation system is Apple's iOS.
-   `ANDROID`: indicates the operation system is Google's Android.

> **Note**: Specify this field when _terminalType_ is not `WEB`.

##### browserInfo (BrowserInfo)

The information about the browser environment where the order is placed.

> **Note**: Specify this parameter when you collect this information during the payment process.

###### acceptHeader (String)

The accept header of the user's browser.

More information:

- Maximum length: 2048 characters

###### javaEnabled (Boolean)

Indicates whether the user's browser is able to run Java. Valid values are:

-   `true`: indicates that the user's browser is able to run Java.
-   `false`: indicates that the user's browser is unable to run Java. The same applies when the value is empty or you do not specify this parameter.

###### javaScriptEnabled (Boolean)

Indicates whether the user's browser is able to run Java. Valid values are:

-   `true`: indicates that the user's browser is able to run JavaScript.
-   `false`: indicates that the user's browser is unable to run JavaScript. The same applies when the value is empty or you do not specify this parameter.

###### language (String)

The language of the user's browser. The value is obtained by using the browser's `navigator.language` property (as defined in IETF BCP 47).

More information:

- Maximum length: 32 characters

###### userAgent (String)

The user agent of the user's browser.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `BLIK` and you collect the information of _blikCode_.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 2048 characters

##### colorDepth (Integer)

The color depth of the user's browser in bits per pixel. The value is obtained by using the browser's screen.colorDepth property. Valid values are `1`, `4`, `8`, `15`, `16`, `24`, `30`, `32`, or `48`. For example, `8` means 8-bit color depth.

More information:

- Value range: 0 - unlimited

##### screenHeight (Integer)

The screen height of the user's device in pixels.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Value range: 1 - unlimited

##### screenWidth (Integer)

The screen width of the user's device in pixels.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Value range: 1 - unlimited

##### timeZoneOffset (Integer)

The time difference between UTC time and the local time of the user's browser, in minutes. The value is obtained by using the `getTimezoneOffset()` property. For example, if the local time of the user's browser is UTC+2, the value of this parameter is `-120`.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Value range: -720 - 720

##### deviceBrand (String)

The brand of the user's device.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

##### deviceModel (String)

The model of the user's device.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 128 characters

##### deviceTokenId (String)

The token identifier of the device.

> **Note**: Specify this parameter if you integrate with the Antom Device Fingerprint client, which is an SDK or JavaScript library that is used to collect device-related information, such as _osType_, _deviceLanguage_, _deviceId_, _websiteLanguage_, and _userAgent_. The device-related information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates. For more information about the Antom Device Fingerprint client, contact Antom Technical Support.

More information:

- Maximum length: 64 characters

##### clientIp (String)

The IP address of the client device.

> **Note**:
>
> Specify this parameter when one of the following conditions is met:
>
> -   You require risk control.
> -   The value of _paymentMethodType_ is `CARD`.
> -   The value of _paymentMethodType_ is `BLIK` and you collect the information of _blikCode_.
>
> Providing this information helps to increase the accuracy of anti-money laundering and fraud detection, and increase payment success rates.

More information:

- Maximum length: 64 characters

##### deviceLanguage (String)

The language of the device where the user places an order.

> **Note**: Specify this parameter if you require risk control. Providing this information helps to identify black-market behavior.

More information:

- Maximum length: 32 characters

##### deviceId (String)

The unique ID of the device the user places an order with.

> **Note**: Specify this parameter if you require risk control. This parameter can be used to build a trusted relationship between users and commonly used devices, thereby reducing risk control interruptions and increasing the payment success rate.

More information:

- Maximum length: 64 characters

##### extendInfo (String)

Extended information.

> **Note**: Specify this field if you need to use the extended information.

More information:

- Maximum length: 2048 characters

## Response parameters

#### result (Result, REQUIRED)

The result of the API call.

##### resultCode (String, REQUIRED)

Result code. The result code that might be returned are listed in the **Result/Error codes** table on this page.

More information:

- Maximum length: 64 characters

##### resultStatus (String, REQUIRED)

Result status. Valid values are:

-   `S`: Indicates that the API call succeeds.
-   `F`: Indicates that the API call fails.
-   `U`: Indicates that the API call might be successful, in process, or failed. For more details, see Result process logic.

##### resultMessage (String, REQUIRED)

Result message that explains the result code.

More information:

- Maximum length: 256 characters

##### newFieldLtgOaq

#### paymentRequestId (String)

The unique ID that is assigned by a merchant to identify a payment request.

> **Note**: This field is returned when _resultCode_ is `PAYMENT_IN_PROCESS`.

More information:

- Maximum length: 64 characters

#### paymentId (String)

The unique ID that is assigned by APO to identify a payment.

> **Note**: This field is returned when _resultCode_ is `PAYMENT_IN_PROCESS`.

More information:

- Maximum length: 64 characters

#### paymentAmount (Amount)

The payment amount that the merchant requests to receive in the order currency.

> **Note**: This field is returned when _resultCode_ is `PAYMENT_IN_PROCESS`.

##### currency (String, REQUIRED)

The 3-letter currency code that follows the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard.

More information:

- Maximum length: 3 characters

##### value (Integer, REQUIRED)

The amount to charge as a positive integer in the smallest currency unit. (That is, 100 cents to charge $1.00, or 100 to charge JPY 100, a 0-decimal currency).

> **Notes**: 
>
> -   For details about the smallest currency unit, see [Smallest unit of the currency](https://docs.antom.com/ac/ref/cc.md#ONkIe).
> -   For details about the minimum payment amount allowed for each payment method, see [Minimum amount rules](https://docs.antom.com/ac/ref/cc.md#q9R5A).

More information:

- Value range: 1 - unlimited

#### paymentData (String)

Used by the Antom client SDK to render the checkout page. This parameter is returned if the merchant app has integrated Antom client SDK. After receiving the parameter, you can call the **showPaymentSheet** API of the Antom client SDK.

More information:

- Maximum length: 20000 characters

#### paymentCreateTime (Datetime)

The date and time when the payment is created.

> **Note**: This field is returned when _resultCode_ is `PAYMENT_IN_PROCESS`.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

#### paymentTime (Datetime)

The date and time when the payment reaches a final state of success.

> **Note**: This field is returned only when the payment reaches a final state of success (the value of _paymentStatus_ is `SUCCESS`).

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

#### pspCustomerInfo (PspCustomerInfo)

The customer information of digital wallets.

> **Note**: This field is returned when the digital wallet can provide the related information.

##### pspName (String)

The name of digital wallets.

> **Note**: This field is returned when the digital wallet can provide the related information.

More information:

- Maximum length: 64 characters

##### pspCustomerId (String)

The customer ID of digital wallets.

> **Note**: This field is returned when the digital wallet can provide the related information.

More information:

- Maximum length: 64 characters

##### displayCustomerId (String)

The customer ID used for display. For example, _loginId_.

> **Note**: This field is returned when the digital wallet can provide the related information.

More information:

- Maximum length: 64 characters

#### orderCodeForm (OrderCodeForm)

Information of the order code.

> **Note**: This parameter is returned when the payment method supports providing the related information.

##### expireTime (Datetime, REQUIRED)

Expiry time of the order code information.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

##### codeDetails (Array<CodeDetail>, REQUIRED)

Details about the code.

More information:

- Maximum size: 4 elements

###### codeValue (String, REQUIRED)

The value of the code.  

-   If the value of _displayType_ is set to`SMALLIMAGE`, `MIDDLEIMAGE`, or `BIGIMAGE`, this parameter indicates a plain or Base64-encoded image URL.
-   If the value of _displayType_ is set to `TEXT`, this parameter indicates a text string.

More information:

- Maximum length: 2048 characters

###### displayType (String, REQUIRED)

Indicates the way to display the code on the UI. Valid values are:

-   `TEXT`: Indicates that the code is directly displayed on the UI as text or a label.
-   `MIDDLEIMAGE`: Indicates that the code is directly displayed on the UI as a small-sized image.
-   `SMALLIMAGE`: Indicates that the code is directly displayed on the UI as a middle-sized image.
-   `BIGIMAGE`: Indicates that the code is directly displayed on the UI as a big-sized image.

##### extendInfo (String)

Extended information.

> **Note**: This field is returned when extended information exists.

More information:

- Maximum length: 2048 characters

#### grossSettlementAmount (Amount)

The value of this field equals to transaction amount multiplied by the value of _settlementQuote_.

> **Note**: This field is returned when the currency exchange is predetermined and the exchange rate is locked at the time of transaction.

##### currency (String, REQUIRED)

The 3-letter currency code that follows the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard.

More information:

- Maximum length: 3 characters

##### value (Integer, REQUIRED)

The amount to charge as a positive integer in the smallest currency unit. (That is, 100 cents to charge $1.00, or 100 to charge JPY 100, a 0-decimal currency).

Notes:

-   For details about the smallest currency unit, see [Smallest unit of the currency](https://global.alipay.com/docs/ac/ref/cc#ONkIe).
-   For details about the minimum payment amount allowed for each payment method, see [Minimum amount rules](https://global.alipay.com/docs/ac/ref/cc#q9R5A).

More information:

- Value range: 0 - unlimited

#### settlementQuote (Quote)

The exchange rate between the settlement currency and transaction currency.

> **Note**: This field is returned when _grossSettlementAmount_ is returned.

##### guaranteed (Boolean)

Guaranteed exchange rate available for payment.

##### quoteId (String)

The unique ID that is assigned by Alipay to identify an exchange rate.

More information:

- Maximum length: 64 characters

##### quoteCurrencyPair (String, REQUIRED)

A currency pair of settlement currency and transaction currency. The two currencies are separated with a slash and use the 3-letter [ISO-4217](https://www.iso.org/iso-4217-currency-codes.html) currency code.

More information:

- Maximum length: 16 characters

##### quotePrice (Decimal, REQUIRED)

The exchange rate used when a currency conversion between settlement currency and transaction currency occurs.

More information:

- Value range: 0 - unlimited

##### quoteStartTime (Datetime)

The date and time when _quotePrice_ is effective.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

##### quoteExpiryTime (Datetime)

The date and time when _quotePrice_ expires.

More information:

- The value follows the [ISO 8601](https://www.iso.org/iso-8601-date-and-time-format.html) standard format. For example, "2019-11-27T12:01:01+08:00".

#### appIdentifier (String)

Android package name, which is used by Android apps to open a checkout page.

> **Note**: This field is returned when _resultCode_ is `PAYMENT_IN_PROCESS` and _terminalType_ is `APP` or `WAP`.

More information:

- Maximum length: 128 characters

#### applinkUrl (URL)

The URL that redirects users to open an app when the target app is installed, or to open a WAP page when the target app is not installed. For Android, the URL is a Native App Link. For iOS, the URL is a Universal Link.

> **Note**: When the value of _resultCode_ is `PAYMENT_IN_PROCESS`, at least one of _schemeUrl_, _applinkUrl,_ and _normalUrl_ is to be returned.

More information:

- Maximum length: 2048 characters

#### normalUrl (URL)

The URL that redirects users to a WAP or WEB page in the default browser or the embedded WebView.

> **Note**: When the value of _resultCode_ is `PAYMENT_IN_PROCESS`, at least one of _schemeUrl_, _applinkUrl,_ and _normalUrl_ is to be returned.

More information:

- Maximum length: 2048 characters

#### schemeUrl (URL)

The URL scheme that redirects users to open an app in an Android or iOS system when the target app is installed.

> **Note**: When the value of _resultCode_ is `PAYMENT_IN_PROCESS`, at least one of _schemeUrl_, _applinkUrl,_ and _normalUrl_ is to be returned.

More information:

- Maximum length: 2048 characters

#### paymentResultInfo (PaymentResultInfo)

The payment result information.

> **Note**: This parameter may be returned when the value of _paymentMethodType_ is `CARD`.

**Scenario: Card** (CARD)

##### cardNo (String)

The masked card number, which just shows part of the card number and can be used to display to the user.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD` and the merchant does not have the PCI qualification.

More information:

- Maximum length: 32 characters

##### cardBrand (String)

The card brand, which can be used to display to the user.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD` .

More information:

- Maximum length: 256 characters

##### cardToken (String)

The token of the card, the value of this parameter is used by _paymentMethodId_ in the [**pay**](https://docs.antom.com/ac/apo/pay.md) [](https://global.alipay.com/docs/ac/ams/payment_cashier)API in subsequent payments.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD` and the merchant does not have the PCI qualification.

More information:

- Maximum length: 128 characters

##### issuingCountry (String)

The issuing country of the card. The value of this parameter is a 2-letter country code that follows [ISO 3166 Country Codes](https://www.iso.org/obp/ui/#search) standard.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD`.

More information:

- Maximum length: 2 characters

##### funding (String)

The funding type of the card. Valid values are:

-   `CREDIT`: indicates a credit card
-   `DEBIT`: indicates a debit card
-   `PREPAID`: indicates a prepaid card
-   `CHARGE`: indicates a charge card
-   `DEFERRED_DEBIT`: indicates a deferred debit card

> **Note**:
>
> This parameter is returned when all the following conditions are met:
>
> -   The value of _paymentMethodType_ is `CARD`.
> -   The value of _cardNo_ is valid.
> -   The information is available in the Alipay card database.

More information:

- Maximum length: 32 characters

##### paymentMethodRegion (String)

The region code that represents the country or region of the payment method. The value of this parameter is a 2-letter [ISO country code](https://www.iso.org/obp/ui/#search) or GLOBAL.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD`.

More information:

- Maximum length: 6 characters

##### threeDSResult (ThreeDSResult)

The result of 3D Secure authentication.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD` and the card authentication type is 3D Secure.

###### threeDSVersion (String, REQUIRED)

The version of 3D Secure protocol. Valid values are:

-   `1.0.2`
-   `2.1.0`
-   `2.2.0`

More information:

- Maximum length: 16 characters

###### eci (String, REQUIRED)

Electronic Commerce Indicator (ECI) that is returned by the card scheme. This parameter is used to indicate the type of cardholder identity authentication. Valid values are:

-   `02` or `05`: indicates fully authenticated transaction.
-   `01` or `06`: indicates attempted authentication transaction.
-   `00` or `07`: indicates non-3D Secure transaction.

More information:

- Maximum length: 2 characters

###### cavv (String)

The cardholder authentication value. The value of this parameter can be Cardholder Authentication Verification Value (CAVV) or Authentication Verification Value (AVV).

> **Note**: This parameter is returned when the cardholder passes the 3D Secure authentication.

More information:

- Maximum length: 64 characters

###### dsTransactionId (String)

The unique transaction identifier assigned by the Directory Server (DS) for 3D Secure authentication.

> **Note**: This parameter is returned for 3D Secure 2.0.

More information:

- Maximum length: 64 characters

###### xid (String)

The unique transaction identifier assigned by the Directory Server (DS) for 3D Secure authentication.

> **Note**: This parameter is returned for 3D Secure 1.0.

More information:

- Maximum length: 64 characters

###### threeDSOffered (Boolean)

Indicates whether 3D Secure authentication was triggered for the payment. Valid values are:

-   `true`: indicates 3D Secure authentication was triggered for the payment. Determine the authentication result by combining the other returned 3D Secure parameters.

-   `false`: indicates 3D Secure authentication was not triggered for the payment.

> **Note**: This parameter may be returned even if the payment fails.

###### threeDStransactionStatusReason (String)

When a transaction is unsuccessful due to 3D Secure authentication failure, you may receive the transaction status reason code returned by this parameter, indicating the reason for the failure.

More information:

- Maximum length: 2 characters

###### challengeCancel (String)

Indicator informing the Access Control Server (ACS) and the Directory Server (DS) that the authentication has been cancelled. Possible values are:

-   `01`: Cardholder selected cancel.
-   `02`: 3DS Requestor cancelled authentication.
-   `03`: Transaction abandoned.
-   `04`: Transaction timed out at ACS — other timeouts.
-   `05`: Transaction timed out at ACS — the first Client Request not received by ACS.
-   `06`: Transaction error.
-   `07`: Unknown.
-   `08`: Transaction timed out at SDK.

More information:

- Maximum length: 2 characters

##### avsResultRaw (String)

The raw AVS result. See [AVS result codes](https://docs.antom.com/ac/apo/risk_methods/#gki8j) to check the valid values.

> **Note**: This parameter is returned when the issuing bank passes this information to Antom.

More information:

- Maximum length: 128 characters

##### cvvResultRaw (String)

The raw Card Verification Value (CVV), Card Security Code (CSC), or Card Verification Code (CVC) result. See [CVV result codes](https://docs.antom.com/ac/apo/risk_methods/#sBWzx) to check the valid values.

> **Note**: This parameter is returned when the issuing bank passes this information to APO.

More information:

- Maximum length: 128 characters

##### networkTransactionId (String)

The unique ID assigned by the card scheme to identify a transaction. The value of this parameter is used by the same parameter of **[pay](https://global.alipay.com/docs/ac/apo/pay)** request in subsequent payments.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://global.alipay.com/docs/ac/apo/pay)** API is `CARD` and 3D Secure or non-3D Secure authentication is successful.

More information:

- Maximum length: 128 characters

##### cardCategory (String)

The payment card category. Valid vaules are: 

-   `CONSUMER`: the personal card
-   `COMMERCIAL`: the business card

> **Note**:
>
> This parameter is returned when all the following conditions are met:
>
> -   The value of _paymentMethodType_ is `CARD`.
> -   The value of _cardNo_ is valid.
> -   The information is available in the APO card database.

More information:

- Maximum length: 32 characters

##### creditPayPlan (CreditPayPlan)

The installment plan information for an installment payment.

> **Note**: This parameter is returned when the buyer successfully made a payment in installments using a card.

###### installmentNum (Integer)

The number of installment payments.

> **Note**: This parameter is returned when the buyer successfully made a payment in installments using a card.

More information:

- Maximum length: 8 characters

###### interval (String)

The interval of each installment payment. The valid value is `MONTH`.

> **Note**: This parameter is returned when the buyer successfully made a payment in installments using a card.

More information:

- Maximum length: 16 characters

##### lastFour (String)

Last 4 digits of the card number.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD` .

More information:

- Maximum length: 4 characters

##### expiryMonth (String)

The month the card expires. Pass in two digits representing the month. For example, if the expiry month is February, the value of this parameter is `02`.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD`.

More information:

- Maximum length: 2 characters

##### expiryYear (String)

The year the card expires. Pass in the last two digits of the year number. For example, if the expiry year is 2025, the value of this parameter is `25`.

> **Note**: This parameter is returned when the value of _paymentMethodType_ in the **[pay](https://docs.antom.com/ac/apo/pay.md)** API is `CARD`.

More information:

- Maximum length: 2 characters

##### fingerprint (String)

Uniquely identifies this particular card number. You can use this attribute to check whether two customers who’ve signed up with you are using the same card number.

More information:

- Maximum length: 256 characters

##### authenticationFlow (String)

For authenticated transactions: how the customer was authenticated by theissuing bank. Valid values are:

-   `CHALLENGE`: the issuing bank authenticated the customer by presenting a traditional challenge window.
-   `FRICTIONLESS`: the issuing bank authenticated the customer via the 3ds2 frictionless flow.

More information:

- Maximum length: 32 characters

##### cardBin (String)

The bin of the card.

More information:

- Maximum length: 32 characters

##### issuerName (String)

The issuer name of the card.

More information:

- Maximum length: 256 characters

##### rrn (String)

Retrieval Reference Number (RRN). This can be provided to track details of the payment, refund or dispute with the card issuer.

More information:

- Maximum length: 32 characters

**Scenario: Wallet** (WALLET)

##### funding (String)

The funding type of the wallet. This parameter is returned when the value of _paymentMethodType_ is `GRABPAY_MY` or `GRABPAY_SG`. Valid values are:

-   `WALLETS`: indicates a regular wallet payment using the wallet balance.
-   `BNPL_POSTPAID`: indicates a buy-now-pay-later payment, and the user pays the full amount.
-   `BNPL_INSTALLMENT`: indicates a buy-now-pay-later payment, and the user pays in installments.

More information:

- Maximum length: 20 characters

##### creditPayPlan (CreditPayPlan)

The installment plan information for an installment payment.

> **Note**: This parameter is returned when the value of _paymentResultInfo.funding_ is `BNPL_INSTALLMENT`.

###### installmentNum (String)

The number of installment payments. The value of this parameter is fixed as `4`.

> **Note**: This parameter is returned when the value of _paymentResultInfo.funding_ is `BNPL_INSTALLMENT`.

More information:

- Maximum length: 8 characters

###### interval (String)

The interval of each installment payment. The valid value is `MONTH`.

> **Note**: This parameter is returned when the value of _paymentResultInfo.funding_ is `BNPL_INSTALLMENT`.

More information:

- Maximum length: 16 characters

#### acquirerInfo (AcquirerInfo)

The information of the acquirer that processes the payment.

##### acquirerName (String)

The name of the acquirer.

More information:

- Maximum length: 64 characters

##### referenceRequestId (String)

The unique ID that is assigned by APO to identify a payment request sent to the acquirer.

More information:

- Maximum length: 64 characters

##### acquirerMerchantId (String)

The unique ID that is assigned by the acquirer to identify a merchant.

More information:

- Maximum length: 64 characters

##### acquirerTransactionId (String)

The unique ID that is assigned by the acquirer to identify a transaction.

More information:

- Maximum length: 64 characters

##### acquirerResultCode (String)

The acquirer's result code that indicates the transaction process result.

More information:

- Maximum length: 64 characters

##### acquirerResultMessage (String)

The result message that describes _acquirerResultCode_ in detail.

More information:

- Maximum length: 64 characters

## More information

About the _order_ field: APO does not verify the consistency of the amount in the _order_ field and the amount in the payment request. The order information is not applied in fund operations either. This field is mainly used for risk control, supervision, regulatory reporting, and consumption records display. Use the _env_ field if the risk control capability provided by APO is needed.

#BUTTON#Sample for the order field#
{
 "order": {
 "referenceOrderId": "102775745075669",
 "orderDescription": "Mi Band 3 Wrist Strap Metal Screwless Stainless Steel For Xiaomi Mi Band 3 ",
 "orderAmount": {
 "value": "500",
 "currency": "USD"
        },
 "goods": \[{
 "referenceGoodsId": "102775745075669",
 "goodsName": "xxx goods",
 "goodsUnitAmount": {
 "currency": "USD",
 "value": "498"
            },
 "goodsQuantity": "1"
        }\],
 "shipping": {
 "shippingName": {
 "fullName": "Bob Day"
            },
 "shippingAddress": {
 "region": "US",
 "state": "California",
 "city": "San Mateo",
 "address1": "400 El Camino Real",
 "address2": "suit 107",
 "zipCode": "95014"
            },
 "shippingCarrier": "USPS",
 "shippingPhoneNo": "9093749555"
        },
 "buyer": {
 "referenceBuyerId": "bob@gmail.com",
 "buyerName": {
 "fullName": "Bob Day"
            },
 "buyerPhoneNo": "+86 18888888888",
 "buyerEmail": "bob@gmail.com"
        },
 "extendInfo": "{ \\"chinaExtraTransInfo\\":{  \\"businessType\\":\\"1|2|3|4|5\\",    \\"hotelName\\":\\"Holiday Inn San Jose|Hyatt Resort San Mateo\\",    \\"checkinTime\\":\\"2018-10-21|2018-10-30\\",   \\"checkoutTime\\":\\"2018-10-24|2018-11-03\\",   \\"flightNumber\\":\\"UA898|CA986\\",    \\"departureTime\\":\\"2018-10-22 20:49|2018-10-23 04:50\\",   \\"admissionNoticeUrl\\":\\"https://www.iconfont.cn/search/index?test\\"}}"

    }
}

## Result process logic

For different request results, different actions need to be taken. See the following list for details:

-   `S`: When this value is returned, the API call succeeds.
-   `F`: When this value is returned, the API call fails. Take actions according to the corresponding result message or call the API again with a new _paymentRequestId_ value. If the issue persists, contact APO Technical Support.
-   `U`: When this value is returned, check the result code:

-   Result code is not `PAYMENT_IN_PROCESS`: The API call fails. Call this API again with a new _paymentRequestId value_.
-   Result code is `PAYMENT_IN_PROCESS`: Check whether one or more of the three URLs (appLinkUrl, normalUrl, schemeUrl) are returned:

-   one or more of the URLs returned: The transaction is created successfully. Redirect your user to the address specified by the URL to complete the payment.
-   no URLs returned: The transaction creation fails. Call the **pay** API again with a new _paymentRequestId_ value. If the issue persists, contact APO Technical Support.

## Result/Error codes

| Code | Value | Message | Further action |
| --- | --- | --- | --- |
| SUCCESS | S | Success | The payment is successful, no further action is needed. |
| ACCESS_DENIED | F | Access is denied. | Contact APO Technical Support for detailed reasons. |
| CURRENCY_NOT_SUPPORT  | F | The currency is not supported. | Contact APO Technical Support for detailed reasons. |
| DO_NOT_HONOR | F | The payment is declined by the issuing bank.  | Retry the payment using a different card or contact the issuing bank. |
| EXPIRED_CODE | F | The payment code is expired.  | The user needs to refresh the payment code. |
| FRAUD_REJECT | F | The transaction cannot be further processed because of risk control. If the user has already paid for the transaction, the transaction will be refunded. | Contact APO Technical Support when one of the following conditions is met:You want to make an appeal. The user does not receive the refund within two weeks. |
| INVALID_ACCESS_TOKEN | F | The access token is expired, revoked, or does not exist. | Check whether accessToken is correct. If not correct, pass in the correct value. If correct, contact APO Technical Support for detailed reasons. |
| INVALID_CONTRACT | F | The parameter values in the contract do not match those in the current transaction. | Check whether the parameter values in the contract match those in the current transaction. If the values match, contact APO Technical Support to troubleshoot the issue. |
| INVALID_MERCHANT_STATUS | F | The merchant status is abnormal because restrictions exist. | Contact APO Technical Support for detailed reasons. |
| INVALID_PAYMENT_CODE | F | The payment code cannot be accepted by Alipay+. | Choose other payment methods. Contact APO Technical Support if the payment method is supported. |
| INVALID_PAYMENT_METHOD_META_DATA | F | The payment method metadata is invalid. | Check whether payment method metadata is correct. If correct, contact APO Technical Support. |
| KEY_NOT_FOUND | F | The private key or public key of APO or the merchant is not found. | Check whether the private key or public key exists. If not, upload the private key in APO Dashboard. |
| MERCHANT_KYB_NOT_QUALIFIED | F | The payment failed because of the merchant's KYB status. The merchant is either not KYB compliant, or the KYB status is not qualified for this transaction. | Contact Antom Technical Support for detailed reasons. |
| MERCHANT_NOT_REGISTERED | F | The merchant is not registered. | Please register the merchant by using the registration interface. Contact APO Technical Support if failed to call the registration API. |
| NO_INTERFACE_DEF | F | API is not defined. | Check whether the URL is correct. Please refer to the endpoint in the API documentation. |
| NO_PAY_OPTIONS | F | The currency is not supported for the transaction. | Check whether the currency is supported by the payment method, or check whether the payment method and currency are consistent with the contract. Contact APO Technical Support for detailed reasons. |
| ORDER_IS_CANCELED | F | The request you initiated has the same paymentRequestId as the previously paid transaction, which is canceled. | Use a new paymentRequestId to initiate the payment again. |
| ORDER_IS_CLOSED | F | The paymentRequestId of your request is already used for a transaction, which is closed.  | Use a new paymentRequestId to initiate a payment. |
| PARAM_ILLEGAL | F | The required parameters are not passed, or illegal parameters exist. For example, a non-numeric input, an invalid date, or the length and type of the parameter are wrong. | Check and verify whether the required request fields (including the header fields and body fields) of the current API are correctly passed and valid. |
| PAYMENT_AMOUNT_EXCEED_LIMIT | F | The payment amount is greater than the maximum amount allowed by the contract or payment method. | Check whether the payment amount exceeds the limit or use a lower amount and try again. Contact APO technical support to know the specific limitation. |
| PAYMENT_COUNT_EXCEED_LIMIT | F | The maximum number of payments exceeds the limit that is specified by the payment method. | Contact APO Technical Support to know the specific limitation. |
| PAYMENT_NOT_QUALIFIED | F | The merchant is not qualified to pay because the merchant is not registered, does not have a contract for <span style="background-color: transparent;">Tokenized Payment</span>, or is forbidden to make a payment. | Contact APO Technical Support for detailed reasons. |
| PROCESS_FAIL | F | A general business failure occurred. | Do not retry. Human intervention is usually needed. It is recommended that you contact APO Technical Support to troubleshoot the issue. |
| REPEAT_REQ_INCONSISTENT | F | The amount or currency is different from the previous request. | Ensure all the fields in the requests are the same or use a new paymentRequestId to initiate the payment again. |
| RISK_REJECT | F | The transaction cannot be further processed because of risk control. If the user has already paid for the transaction, the transaction will be refunded.  | If the user does not receive the refund within two weeks, contact APO Technical Support. |
| SETTLE_CONTRACT_NOT_MATCH | F | No matched settlement contract can be found. | Check the following for a solution: Specify one settlement currency from the multiple currencies that the merchant signed up for. Check if the settlement currency is specified in the settlement contracts. The merchant didn't sign a settlement contract. Contact APO Technical Support. |
| SYSTEM_ERROR | F | A system error occurred. | Do not retry, and contact APO Technical Support for more details. |
| USER_AMOUNT_EXCEED_LIMIT | F | The payment amount exceeds the user payment limit. | Create a new payment by using an amount less than or equal to the account's available balance, or contact APO Technical Support. |
| USER_BALANCE_NOT_ENOUGH | F | The payment cannot be completed because the user balance in the corresponding payment method is not enough. | Please top up the account or choose other payment methods. |
| USER_KYC_NOT_QUALIFIED | F | The payment failed because of the user's KYC status. The user is either not KYC compliant, or the KYC status is not qualified for this transaction (for example, limitations on the payment amount or product information). | Complete the KYC verification first. |
| PAYMENT_IN_PROCESS | U | The payment is being processed. | Get any of the URLs (appLinkUrl,  normalUrl, schemeUrl) and open the cashier page. If no URL is returned, call the pay API again with a new paymentRequestId value. If the issue persists, contact APO Technical Support. |
| REQUEST_TRAFFIC_EXCEED_LIMIT | U | The request traffic exceeds the limit. | Call the API again to resolve the issue. If not resolved, contact APO Technical Support. |
| UNKNOWN_EXCEPTION | U | An API call has failed, which is caused by unknown reasons. | Call the interface again to resolve the issue. If not resolved, contact APO Technical Support. |
| USER_NOT_EXIST | F | The user does not exist on the wallet side. | Contact APO Technical Support for detailed reasons. |
| ORDER_NOT_EXIST | F | The order does not exist. | Check whether paymentId is correct. |
| ORDER_STATUS_INVALID | F | The transaction cannot be further processed because the order status is invalid. | Check the order status of the transaction or contact APO Technical Support for detailed reasons. |
| USER_PAYMENT_VERIFICATION_FAILED | F | User fails to pass the payment verification in the methods like OTP, PIN, and so on. | Contact APO Technical Support to know the specific reasons. |
| USER_STATUS_ABNORMAL | F | The user status is abnormal on the wallet side. | Contact APO Technical Support to know the specific reasons. |
| VERIFY_TIMES_EXCEED_LIMIT | F | The current verification code failed to pass the payment verification too many times.  | The user must get a new verification code. |
| VERIFY_UNMATCHED | F | The verification code is invalid.  | The user must get a new verification code. |
| AUTHENTICATION_REQUIRED | F | 3D Secure authentication is required. | Reinitiate the payment and redirect the user to perform 3D Secure authentication. |
| SELECTED_CARD_BRAND_NOT_AVAILABLE | F | The card brand that the user selected to pay is not available. | The card brand that the user selected to pay is not available. |
| PAYMENT_PROHIBITED | F | The payment cannot be processed because the goods are prohibited from sale in the country. | You are not allowed to appeal against this transaction. |
| INVALID_EXPIRATION_DATE | F | The value of paymentMethod.paymentMethodMetaData.expiryYear or paymentMethod.paymentMethodMetaData.expiryDate is invalid.  | Check whether the value of paymentMethod.paymentMethodMetaData.expiryYear or paymentMethod.paymentMethodMetaData.expiryDate is correct:If not correct, pass in the correct value. If correct, contact APO Technical Support for detailed reasons. |
| INVALID_CARD_NUMBER | F | The number of the card used for the transaction is invalid.  | Check whether the value of paymentMethod.paymentMethodMetaData.cardno is correct:If not correct, pass in the correct value and try again. If correct, this card is not supported by the transaction, use another card to pay the transaction. |
| CARD_NOT_SUPPORTED | F | The card used for the transaction is not supported. | Use another card to pay the transaction. |

## Request

### ALIPAY, APP, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0517884936248XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "iJ9lsVgTx8pX7qJpvW6rfqEE2Kdv9M3lgL8e1999ydfz52uMSqwvT3qXYw8IFBYt",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### ALIPAY, APP, INST

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0656237919440XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "Mbu1XMcI8TsH6oIVbioGeyvXA544N9UTIeHJ0YMTLYhRomPU0n7Je2cp3kiCADbp",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### ALIPAY, H5, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "WAP"
  },
  "order": {
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0987276268789XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "vvdD1f7eRsRs5NlYjNqIEKU7GgACsUJ4Xk8NqyNqHI4uBPUyuiGtA4vsxC2nTGuf",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### ALIPAY, H5, INST

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "WAP"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0401413682655XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "Lyh9DAM2S16mubVSXbVjhmsZS3dF4ThgHXANOG8dV5InbrbS9Tq0LS6BnwBwTyzU",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### ALIPAY, DESKTOP, DIRECT

```json
{
  "env": {
    "terminalType": "WEB"
  },
  "order": {
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0750145555106XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "Ud4O9drcIa9TIL6MHexbnhh31Jblw4WqLzwBkw0b6ufZLmFLzwExkzCt518ntpbZ",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### ALIPAY, DESKTOP, INST

```json
{
  "env": {
    "terminalType": "WEB"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "CNY",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_04064611172949XXXX"
  },
  "paymentAmount": {
    "currency": "CNY",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "ALIPAY_CN"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "Y0RrWTtZCEnvvrhIdVIF0WgUFWSGByCstM1SMrYGaWikP1Pr96IGzlnuZ63EHIwe",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, APP, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0396988230426XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "PAY_0396988230426XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, APP, INST

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0955543630180XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "PAY_0955543630180XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, H5, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "WAP"
  },
  "order": {
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0446885729423XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "PAY_0446885729423XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, H5, INST

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "WAP"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_00820309274383XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "PAY_00820309274383XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, DESKTOP, DIRECT

```json
{
  "env": {
    "terminalType": "WEB"
  },
  "order": {
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0697502532476XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "PAY_0697502532476XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### GCASH, INST, DESKTOP

```json
{
  "env": {
    "terminalType": "WEB"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "PHP",
      "value": "1314"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_00649739664650XXXX"
  },
  "paymentAmount": {
    "currency": "PHP",
    "value": "1314"
  },
  "paymentMethod": {
    "paymentMethodType": "GCASH"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "https://global.alipay.com/doc/cashierpayment/intro",
  "paymentRequestId": "PAY_00649739664650XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### DANA, APP, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "orderAmount": {
      "currency": "IDR",
      "value": "131400"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0821380839284XXXX"
  },
  "paymentAmount": {
    "currency": "IDR",
    "value": "131400"
  },
  "paymentMethod": {
    "paymentMethodType": "DANA"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "PAY_0821380839284XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### DANA, APP, INST

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "APP"
  },
  "order": {
    "merchant": {
      "referenceMerchantId": "SM_001"
    },
    "orderAmount": {
      "currency": "IDR",
      "value": "131400"
    },
    "orderDescription": "Cappuccino #grande (Mika's coffee shop)",
    "referenceOrderId": "ORDER_0948666170462XXXX"
  },
  "paymentAmount": {
    "currency": "IDR",
    "value": "131400"
  },
  "paymentMethod": {
    "paymentMethodType": "DANA"
  },
  "paymentNotifyUrl": "https://www.gaga.com/notify",
  "paymentRedirectUrl": "imeituan://",
  "paymentRequestId": "PAY_0948666170462XXXX",
  "productCode": "CASHIER_PAYMENT",
  "settlementStrategy": {
    "settlementCurrency": "USD"
  }
}
```

### DANA, H5, DIRECT

```json
{
  "env": {
    "osType": "ANDROID",
    "terminalType": "WAP"
  },
  "order": {
[...]
